Subject: Re: Low performance Intel 10GE NIC (3.2.10) on 2.6.38 Kernel

From: Peter Zijlstra <[email-masked]>
Date: Fri, 15 Apr 2011 10:57:37 +0200

On Thu, 2011-04-14 at 18:57 +0200, Eric Dumazet wrote:
> Le jeudi 14 avril 2011 à 18:56 +0200, Peter Zijlstra a écrit :
> > On Thu, 2011-04-14 at 09:42 -0700, Alexander Duyck wrote:
> > 
> > > I'm doing some more digging into this now.  One thought that occurred to 
> > > me is that if the patch you mention is having some sort of effect this 
> > > could be a sign of perhaps a kernel timer or scheduling problem.
> > 
> > Right, so the removal of the NO_HZ throttle will allow the CPU to go
> > into C states more often, this could result in longer wake-up times for
> > IRQs.
> > 
> > We reverted because:
> >   - it caused significant battery drain due to not going into C states
> >     often enough, and
> >   - its a much better idea to implement these things in the idle
> >     governor since it already has the job of guestimating the idle
> >     duration.
> > 
> > I really can't remember back far enough to even come up with a theory of
> > why kernels prior to merging the NO_HZ throttle would not exhibit this
> > problem.
> > 
> > 
> > 
> 
> Normally, Wei Gu already asked to not use C states.
> 
> http://h20000.www2.hp.com/bc/docs/support/SupportManual/c01804533/c01804533.pdf
> 
> How can we/he check this ?

Not quite sure, I think powertop has something that measures C-state
usage, but if the BIOS is lying to us (pretty good bet since he's using
HP crap^W) there's nothing much we can do about that.

Another thing that could be causing pain in NO_HZ transitions is if
we're having to switch to timer broadcast mode when we go into NO_HZ,
I'm not sure if HP systems are affected by this, nor am I exactly sure
which DL580 he's got.